import { KeyPair } from "./KeyPair";
import { Address } from 'bsv';
import { IndexClient } from "./IndexClient";
import { Envelopes } from "./Envelopes";
export declare class Wallet {
    protected _keypair: KeyPair;
    protected _envelopes: Envelopes;
    protected _indexclient: IndexClient;
    protected _proofs: {
        [key: string]: any;
    };
    protected _use_dsnt: boolean;
    constructor(wif: string);
    get Address(): typeof Address;
    get PublicKey(): string;
    get Balance(): number;
    get Envelopes(): Envelopes;
    get EnvelopesCopy(): string;
    get Unspents(): any[];
    set Unspents(val: any[]);
    set UseDsnt(val: boolean);
    get UnspentEnvelops(): any[];
    sleep(delay?: number): Promise<void>;
    clear(): void;
    utxofetch(): Promise<any>;
    spend(to: string, amount: number, utxos?: any, param_dsnt?: boolean): {
        txid: any;
        rawhex: any;
    } | null;
    spendEnvelopes(to: string, amount: number, envelopes?: any, param_dsnt?: boolean): {
        txid: any;
        rawhex: any;
    } | null;
    updateSpent(txraw: string, utxos: any): void;
    updateSpentEnvelopes(txraw: string, envelopes: any): void;
    isChange(txout: any): boolean;
    decode(rawtx: string): any;
    gettxproof: (txn: any, txns: any) => Promise<any>;
}
//# sourceMappingURL=Wallet.d.ts.map