// a private and public key pair
import {PrivKey as PrivateKey, PubKey as PublicKey, Address, KeyPair as BsvKeyPair, Script} from 'bsv'

export class KeyPair {
    privateKey:any
    publicKey:any
    constructor(priv:any, pub:any) {
        this.privateKey = priv
        this.publicKey = pub
    }
    static fromWif(wif:string): KeyPair {
        const pk = PrivateKey.fromWif(wif)
        return KeyPair.fromPrivateKey(pk)
    }
    static fromRandom():KeyPair {
        const bsvkp = new BsvKeyPair().fromRandom()
        return new KeyPair(bsvkp.privKey, bsvkp.pubKey)
    }
    static fromPrivateKey(pk:any):KeyPair {
        const privateKey = pk
        const publicKey = PublicKey.fromPrivKey(pk)
        return new KeyPair(privateKey, publicKey)
    }
    toAddress(): typeof Address {
        return Address.fromPubKey(this.publicKey,'livenet')
    }
    toBsvKeyPair(): typeof BsvKeyPair {
        return new BsvKeyPair().fromPrivKey(this.privateKey)
    }
    toWif():string {
        return this.privateKey.toWif()
    }
    toScript(): typeof Script {
        return this.toAddress().toTxOutScript()
    }
}