// A Bitcoin Token envelope
// could be a utxo when unspent or could be a transaction input when getting spent
// has a status (unspent/spent)
// has a proof
// has list of transactions for inputs

export class TokenEnvelope {
    // unspent or spent
    public status = 'unspent'
    // utxo that holds these tokens when unspent
    public utxo:any = null
    // satoshi tokens in this envelope
    public satoshis = 0
    // merkle proof for these tokens when mined
    public proof = null
    // array of input transaction
    public txns:any[] = []

    constructor(object?:any) {
        if (object && object.status !== undefined) this.status = object.status
        if (object && object.utxo !== undefined) this.utxo = object.utxo
        if (object && object.satoshis !== undefined) this.satoshis = object.satoshis
        if (object && object.proof !== undefined) this.proof = object.proof
        if (object && object.txns !== undefined) this.txns = object.txns
    }

    get isUnspent():boolean { return this.status === 'unspent' }

    markSpent() {
        if (!this.isUnspent) throw new Error(`already spent!`)
        this.status='spent'
    }
}