import { IndexClient } from '../src/IndexClient'
import {Wallet} from '../src/Wallet'
import { KeyPair } from '../src/KeyPair'

const wif= 'Ky6SheAgy1QsRZqCeRGgsaobxbyxzJDC2St4k8e8Zumb1jT8TmEn'
//'KxG9aVyJXJvNF9rCrRupmH1wkn2FesQFUCt8zveRnTZUaXSB4PRV'

test('Wallet spend', async () => {
    const w = new Wallet(wif)
    // const utxos = await api.getUnspents(w.Address.toString())
    const utxotest = await w.utxofetch()
    // const selectedutxo = wallet.Envelopes.selectUnspents(1000)
    // const build = wallet.spend(wallet.Address.toString(),wallet.Balance,selectedutxo)

    const utxos = w.Envelopes.selectUnspents(1000)
    const txbuilt = w.spend("1LfmWEwNe214Zc6QfWjApM8ZbhawGT9iCn", 1000, utxos)
    // console.log(txbuilt)
    expect(txbuilt?.rawhex).toBeDefined()
    expect(txbuilt?.rawhex.length).toBeGreaterThan(20)
    // const broadcastResult = await api.broadcast(txbuilt.rawhex)
    // console.log(broadcastResult)
    // expect(broadcastResult.length).toBe(64)
},20000)

test ('wallet fetch', async () => {
    const w = new Wallet(wif)
    const utxotest = await w.utxofetch()
    console.log(`ENVELOPES`,w.Envelopes)
    expect(utxotest).toBeDefined()
    
    expect(w.Balance).toBeGreaterThan(0)
},20000)

test ('wallet fetch double', async () => {
    const w = new Wallet(wif)
    const utxotest = await w.utxofetch()
    expect(utxotest).toBeDefined()
    const balance1 = w.Balance
    expect(w.Balance).toBeGreaterThan(0)
    const utxotest2 = await w.utxofetch()
    expect(utxotest2).toBeDefined()
    expect(w.Balance).toBeGreaterThan(0)
    expect(w.Balance).toBe(balance1)
},20000)

test ('wallet fetch with build', async () => {
    const w = new Wallet(wif)
    const utxotest = await w.utxofetch()
    expect(utxotest).toBeDefined()
    const balance1 = w.Balance
    expect(w.Balance).toBeGreaterThan(0)

    //spend something
    const selected = w.Envelopes.selectUnspents(500)
    const build = w.spend(KeyPair.fromRandom().toAddress().toString(), 500, selected)

    //update again
    const utxotest2 = await w.utxofetch()
    w.Unspents = utxotest2
    expect(utxotest2).toBeDefined()
    expect(w.Balance).toBeGreaterThan(0)
    expect(w.Balance).toBe(balance1)

    // update the spent
    w.updateSpent(build?.rawhex, selected)
    const balance2 = w.Balance
    expect(w.Balance).toBe(balance1 - 500 -113)

},20000)
