import { KeyPair } from '../src'
import {Wallet} from '../src/Wallet'

const wif='KxG9aVyJXJvNF9rCrRupmH1wkn2FesQFUCt8zveRnTZUaXSB4PRV'

const unspents=[
        {
                height: 693098,
                tx_pos: 0,
                tx_hash: '3ab9cb22198b4de77dbd7848eb8795d269a5de36933a5ffe87ad6e167e144ad5',
                value: 1000,
                script: '76a914a7e7b30ab0580dc8a090182d97903e056d4f080888ac'
              },
              {
                height: 693098,
                tx_pos: 1,
                tx_hash: '3ab9cb22198b4de77dbd7848eb8795d269a5de36933a5ffe87ad6e167e144ad5',
                value: 2000,
                script: '76a914a7e7b30ab0580dc8a090182d97903e056d4f080888ac'
              }
]

test('Wallet Test', () => {
        const w = new Wallet(wif)
        expect(w).toBeInstanceOf(Wallet)
})

// test('Wallet no wif', () => {
//         const wiffy="null"
//         expect(new Wallet(wiffy)).toThrowError()
// })

test('Wallet balance', () => {
        const w = new Wallet(wif)
        w.Unspents = unspents
        expect(w.Balance).toBe(3000)
})

test('Wallet envelopes', () => {
        const w = new Wallet(wif)
        w.Unspents = unspents
        expect(w.Balance).toBe(3000)
        expect(w.Envelopes.Balance).toBe(3000)
        w.Envelopes.load(w.EnvelopesCopy)
        expect(w.Balance).toBe(3000)
})

test('Wallet balance no unspents', () => {
        const w = new Wallet(wif)
        expect(w.Balance).toBe(0)
})

test('Wallet balance no unspents', () => {
        const w = new Wallet(wif)
        const selected = w.Envelopes.selectUnspents(1000)
        expect(selected).toBeDefined()
})

test('Wallet decode', () => {
        const w = new Wallet(wif)
        expect(w.decode('undefined')).toBeNull()
})

test('Wallet balance no unspents', () => {
        const w = new Wallet(wif)
        w.Unspents = unspents
        expect(w.Balance).toBe(3000)
        w.clear()
        expect(w.Balance).toBe(0)
})

test('Wallet select utxos', () => {
        const w = new Wallet(wif)
        w.Unspents = unspents
        // select will choose biggest first
        const selected900 = w.Envelopes.selectUnspents(900)
        expect(selected900.length).toBe(1)
        const selected1000 = w.Envelopes.selectUnspents(1000)
        expect(selected1000.length).toBe(1)
        const selected1001 = w.Envelopes.selectUnspents(1001)
        expect(selected1001.length).toBe(1)
        const selected3000 = w.Envelopes.selectUnspents(3000)
        expect(selected3000.length).toBe(2)
        const selected9999 = w.Envelopes.selectUnspents(9999)
        expect(selected1001.length).toBe(1)
})

test('wallet mark spent', () => {
        const w = new Wallet(wif)
        const merchant = new Wallet(KeyPair.fromRandom().toWif())
        w.Unspents = unspents
        const balance1 = w.Balance
        expect(balance1).toBe(3000)
        expect(w.Envelopes.utxos.length).toBe(2)
        const selectedfirst = w.Envelopes.selectUnspents(1000)
        // console.log(`first`,selectedfirst)
        const buildfirst = w.spend(w.Address.toString(), 1000, selectedfirst)
        expect(selectedfirst.length).toBe(1)
        w.updateSpent(buildfirst?.rawhex,selectedfirst)
        // 1 + 1 spent, splits into 2 = 1 +2 =3
        expect(w.Envelopes.utxos.length).toBe(3)
        expect(w.Balance).toBe(2000+1000-113)
        const selected2000 = w.Envelopes.selectUnspents(2000)
        const buildsecond = w.spend(w.Address.toString(), 2000, selected2000)
        // console.log(`s2`,selected2000)
        //will select 1000 + 1000
        expect(selected2000.length).toBe(2)
        w.updateSpent(buildsecond?.rawhex,selected2000)
        // we can still keep on building
        expect(w.Envelopes.utxos.length).toBe(2)
        //?
        expect(w.Balance).toBe(2887)
        const selectedlast = w.Envelopes.selectUnspents(1000)
        const buildlast = w.spend(w.Address.toString(), 1000, selectedlast)
        expect(buildlast).toBeDefined()
})

export { wif }
